#!/usr/bin/perl -w

use strict;
use SOAP::Lite;
use HTTP::Cookies;
use Data::Dumper;
use Term::ReadLine;
#use LWP::Debug qw (+);

# read in username/password
my $term = Term::ReadLine->new('testauth');
my $attribs = $term->Attribs;

my $username = $term->readline('login name> ');
chomp $username;

# mask typed characters for password
$attribs->{redisplay_function} = $attribs->{shadow_redisplay};
my $password = $term->readline('password> ');
undef $attribs->{redisplay_function};
chomp $password;


my $soaphost = "127.0.0.1";
my $soapport = 83;

my $cookie_jar = HTTP::Cookies->new(ignore_discard => 1);
my $soap = SOAP::Lite
	-> ns('http://proxmox.com/PVE/ConfigServer')
	-> on_fault (sub { 
	    my($soap, $res) = @_; 
	    die ref $res ? $res->faultstring : $soap->transport->status, "\n";
	})
	-> proxy("http://$soaphost:$soapport", cookie_jar => $cookie_jar,
		 credentials => [
				 "$soaphost:$soapport", # host:port
				 'PVE SOAP Server',     # realm
				 $username, $password
				 ]);

for (;;) {
    my $res = $soap->alive()->result;
    print "soap->alive(): $res\n";
    sleep(1);
}

